'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var InfiniteScroll = function (_React$Component) {
    _inherits(InfiniteScroll, _React$Component);

    function InfiniteScroll(props) {
        _classCallCheck(this, InfiniteScroll);

        var _this = _possibleConstructorReturn(this, (InfiniteScroll.__proto__ || Object.getPrototypeOf(InfiniteScroll)).call(this, props));

        _this.handleScroll = _this.handleScroll.bind(_this);
        return _this;
    }

    _createClass(InfiniteScroll, [{
        key: 'handleScroll',
        value: function () {
            function handleScroll() {
                var _refs$scroller = this.refs.scroller,
                    firstChild = _refs$scroller.firstChild,
                    lastChild = _refs$scroller.lastChild,
                    scrollTop = _refs$scroller.scrollTop,
                    offsetTop = _refs$scroller.offsetTop,
                    offsetHeight = _refs$scroller.offsetHeight;

                var top = firstChild.offsetTop;
                var bottom = lastChild.offsetTop + lastChild.offsetHeight;
                var scrollUp = scrollTop + offsetTop;
                var scrollDown = scrollUp + offsetHeight;

                if (scrollDown >= bottom) {
                    this.props.onReachBottom();
                } else if (scrollUp <= top) {
                    this.props.onReachTop();
                }
            }

            return handleScroll;
        }()
    }, {
        key: 'render',
        value: function () {
            function render() {
                return _react2['default'].createElement(
                    'div',
                    {
                        ref: 'scroller',
                        style: { overflow: 'auto', height: '100%' },
                        onScroll: this.handleScroll
                    },
                    this.props.children
                );
            }

            return render;
        }()
    }]);

    return InfiniteScroll;
}(_react2['default'].Component);

InfiniteScroll.propTypes = {
    children: _react.PropTypes.node.isRequired,
    onReachBottom: _react.PropTypes.func,
    onReachTop: _react.PropTypes.func
};

InfiniteScroll.defaultProps = {
    onReachBottom: function () {
        function onReachBottom(f) {
            return f;
        }

        return onReachBottom;
    }(),
    onReachTop: function () {
        function onReachTop(f) {
            return f;
        }

        return onReachTop;
    }()
};

exports['default'] = InfiniteScroll;